<?php

namespace Revolut\Payment\Api;

interface FastCheckoutManagementInterface
{
    /**
     * Creates card for Express checkout
     *
     * @api
     * @return mixed
     */
    public function addToCart();

    /**
     * Loads shipping options for selected address
     *
     * @api
     * @return mixed
     */
    public function loadShippingOptions();
    
    /**
     * Sets selected shipping option
     *
     * @api
     * @return mixed
     */
    public function setShippingOption();
    
    /**
     * Validate Order order
     *
     * @api
     * @return mixed
     */
    public function validateOrder();
    
    /**
     * Get params
     *
     * @api
     * @return string
     */
    public function getParams();
}
