<?php

namespace Revolut\Payment\Api;

use Magento\Quote\Api\Data\PaymentInterface;

interface OrderManagementInterface
{
    /**
     * Create Order
     *
     * @api
     * @return array
     */
    public function create();

    /**
     * Cancel Order
     *
     * @api
     * @return array
     */
    public function cancel();
    
    /**
     * Handle webhook callbacks
     *
     * @api
     * @return array
     */
    public function webhook();
    
    /**
     * Create Magento order
     *
     * @api
     * @param PaymentInterface $paymentMethod
     * @return array
     */
    public function placeOrder(PaymentInterface $paymentMethod);
}
