<?php

namespace Revolut\Payment\Block\PaymentRequest;

use Revolut\Payment\Model\Source\Mode;
use Revolut\Payment\Model\Helper\ConstantValue;
use Magento\Framework\View\Element\Template;
use Magento\Framework\Registry;
use Revolut\Payment\Gateway\Config\RevolutPaymentRequest\Config as RevolutPaymentRequestConfig;
use Revolut\Payment\Gateway\Config\Config as RevolutConfig;
use Magento\Store\Model\StoreManagerInterface;

class PaymentRequestButton extends Template
{
    /**
     * @var Registry
     */
    protected $registry;

    /**
     * @var RevolutPaymentRequestConfig
     */
    protected $configHelper;
    
    /**
     * @var RevolutConfig
     */
    protected $revolutConfigHelper;

    /**
     * @var String
     */
    public $revolutSdkUrl;
    
    /**
     * @var StoreManagerInterface
     */
    public $storeManager;

    /**
     * Button constructor.
     *
     * @param Template\Context $context
     * @param RevolutPaymentRequestConfig $configHelper
     * @param RevolutConfig $revolutConfigHelper
     * @param Registry $registry
     * @param StoreManagerInterface $storeManager
     * @param array $data
     */
    public function __construct(
        Template\Context $context,
        RevolutPaymentRequestConfig $configHelper,
        RevolutConfig $revolutConfigHelper,
        Registry $registry,
        StoreManagerInterface $storeManager,
        array $data = []
    ) {
        parent::__construct($context, $data);

        $this->registry = $registry;
        $this->configHelper = $configHelper;
        $this->revolutConfigHelper = $revolutConfigHelper;
        $this->storeManager = $storeManager;
        $this->getRevolutSdk();
    }

     /**
      * @return string
      */
    public function getStoreCode()
    {
        return $this->storeManager->getStore()->getCode();
    }

    /**
     * @return int
     */
    public function getProductId()
    {
        $product = $this->registry->registry('product');
        if ($product) {
            return $product->getId();
        }
        return 0;
    }
}
